---
title: conic-gradient()
slug: Web/CSS/conic-gradient()
tags:
  - CSS
  - CSS Function
  - CSS Images
  - Function
  - Graphics
  - Layout
  - Reference
  - Web
  - gradient
---
<div>{{CSSRef}}</div>

<p>The <strong><code>conic-gradient()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Functions">function</a> creates an image consisting of a gradient with color transitions rotated around a center point (rather than radiating from the center). Example conic gradients include pie charts and color wheels. The result of the <code>conic-gradient()</code> function is an object of the {{CSSxRef("&lt;gradient&gt;")}} data type, which is a special kind of {{CSSxRef("&lt;image&gt;")}}.</p>

<div>{{EmbedInteractiveExample("pages/css/function-conic-gradient.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div class="notecard note"></div>

<h2 id="Syntax">Syntax</h2>

<pre class="language-css notranslate" id="css">/* A conic gradient rotated 45 degrees,
   starting blue and finishing red */
conic-gradient(from 45deg, blue, red);

/* A bluish purple box: the gradient goes from blue to red,
   but as only the bottom right quadrant is visible, as the
   center of the conic gradient is in at the top left corner */
conic-gradient(from 90deg at 0 0, blue, red);

/* Colorwheel */
background: conic-gradient(
    hsl(360, 100%, 50%),
    hsl(315, 100%, 50%),
    hsl(270, 100%, 50%),
    hsl(225, 100%, 50%),
    hsl(180, 100%, 50%),
    hsl(135, 100%, 50%),
    hsl(90, 100%, 50%),
    hsl(45, 100%, 50%),
    hsl(0, 100%, 50%)
);</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt>{{CSSxRef("&lt;angle&gt;")}}</dt>
 <dd>Preceded by the <code>from</code> keyterm, and taking an angle as its value, defines the gradient rotation in clockwise direction.</dd>
 <dt><code>&lt;position&gt;</code></dt>
 <dd>Using the same length, order and keyterm values as the <a href="/en-US/docs/Web/CSS/background-position">background-position</a> property, the position defines center of the gradient. If omitted, the default value is <code>center</code>, meaing the gradient will be centered, .</dd>
 <dt><code>&lt;angular-color-stop&gt;</code></dt>
 <dd>A color-stop's {{CSSxRef("&lt;color&gt;")}} value, followed by one or two optional stop positions, (an {{CSSxRef("&lt;angle&gt;")}} along the gradient's circumference axis).</dd>
 <dt><code>&lt;color-hint&gt;</code></dt>
 <dd>Th color-hint is an interpolation hint defining how the gradient progresses between adjacent color stops. The length defines at which point between two color stops the gradient color should reach the midpoint of the color transition. If omitted, the midpoint of the color transition is the midpoint between two color stops.</dd>
 <dd>
 <div class="note">
 <p><strong>Note:</strong> Rendering of <a href="#Gradient_with_multiple_color_stops">color stops in CSS gradients</a> follows the same rules as color stops in <a href="/en-US/docs/Web/SVG/Tutorial/Gradients">SVG gradients</a>.</p>
 </div>
 </dd>
</dl>

<h2 id="Description">Description</h2>

<p>As with any gradient, a conic gradient has <a href="/en-US/docs/CSS/image#no_intrinsic">no intrinsic dimensions</a>; i.e., it has no natural or preferred size, nor a preferred ratio. Its concrete size will match the size of the element it applies to, or size of the <code>&lt;image&gt;</code> is set to something other than the element size.</p>

<p>To create a conic gradient that repeats so as to fill a 360 degree rotation, use the {{CSSxRef("repeating-conic-gradient")}} function instead.</p>

<p>Because <code>&lt;gradient&gt;</code>s belong to the <code>&lt;image&gt;</code> data type, they can only be used where <code>&lt;image&gt;</code>s can be used. For this reason, <code>conic-gradient()</code> won't work on {{CSSxRef("background-color")}} and other properties that use the {{CSSxRef("&lt;color&gt;")}} data type.</p>

<div class="notecard note">
<p>Why is it called a "conic" gradient? If the color stops are much lighter on one side than the other, it can look like a cone from above.</p>
</div>

<h3 id="Composition_of_a_conic_gradient">Composition of a conic gradient</h3>

<p>The conic-gradient syntax is similar to the radial-gradient syntax, but the color-stops are placed around a gradient arc, the circumference of a circle, rather than on the gradient line emerging from the center of the gradient. With conic gradients, the colors transition as if spun around the center of a circle, starting at the top and going clockwise. In a radial gradient, the colors transition from the center of an ellipse, outward, in all directions.</p>

<p><img alt="color stops along the circumference of a conic gradient and the axis of a radial gradient." src="https://mdn.mozillademos.org/files/16361/Screenshot_2018-11-29_21.09.19.png" style="height: 258px; width: 515px;"></p>

<p>A conic gradient is specified by indicating a rotation angle, the center of the gradient, and then specifying a list of color-stops. Unlike linear and radial gradients, whose color-stops are placed by specifying a <a href="/en-US/docs/Web/CSS/length">length</a>, the color-stops of a conic gradient are specified with an <a href="/en-US/docs/Web/CSS/angle">angle</a>. Units include <code>deg</code> for degrees, <code>grad</code> for gradients, <code>rad</code> for radians, and <code>turn</code> for turns. There are 360 degrees, 400 gradians, 2π radians, and 1 turn in a circle. Browsers supporting conic gradients also accept percent values, with 100% equaling 360 degrees, but this is not in the specification.</p>

<p>Similar to radial gradients, the conic gradient syntax provides for positioning the center of the gradient anywhere within, or even outside, the image. The values for the position are similar to the syntax for 2-value background-position.</p>

<p>The gradient arc is the circumference of the gradient. The <em>starting point</em> of the gradient or arc is north, or 12:00pm. The gradient is then rotated by the <em>from</em> angle. The colors of the gradient are determined by the angled color stops, their starting points, ending points, and, in between, and optional angled color-stop points. The transitions between colors can be altered with color hints between adjacent colors' color stops.</p>

<h4 id="Customizing_gradients">Customizing gradients</h4>

<p>By adding more angled color-stop points on the gradient arc, you can create a highly customized transition between multiple colors. A color-stop's position can be explicitly defined by using an {{CSSxRef("&lt;angle&gt;")}}. If you don't specify the location of a color stop, it is placed halfway between the one that precedes it and the one that follows it. If you don't specify an angle for the first or last color stop, their values are 0deg and 360deg respectively. The following two gradients are equivalent</p>

<pre class="brush: css notranslate">conic-gradient(red, orange, yellow, green, blue);
conic-gradient(red 0deg, orange 90deg, yellow 180deg, green 270deg, blue 360deg);</pre>

<p>By default, colors transition smoothly from the color at one color stop to the color at the subsequent color stop, with the midpoint between the colors being the half way point between the color transition. You can move this color transition midpoint to any point between two color stops by adding a color hint, indicating where the middle of the color transition should be. The following is solid red from the start to the 10% mark, transitions from red to blue over 80% of the turn, with the final 10% being solid blue. The midpoint of the red to blue gradient change, however, is at the 20% mark rather than the 50% mark as would have happened without the 80grad, or 20%, color hint.</p>

<pre class="brush: css notranslate">conic-gradient(red 40grad, 80grad, blue 360grad);</pre>

<p>If two or more color stops are at the same location, the transition will be a hard line between the first and last colors declared at that location. To use conic gradients to create pie charts --- which is NOT the correct way to create pie charts as background images are not accessible -- use hard color stops, where the color stop angles for two adjacent color stops are the same. The easiest way to do this is to use multip position colors stops. The following two declarations are equivalent:</p>

<pre class="brush: css notranslate">conic-gradient(#fff 0.09turn, #bbb 0.09turn, #bbb 0.27turn, #666 0.27turn, #666 0.54turn, #000 0.54turn);
conic-gradient(#fff 0turn 0.09turn, #bbb 0.09turn 0.27turn, #666 0.27turn 0.54turn, #000 0.54turn 1turn);</pre>

<p>Color stops should be listed in ascending order. Subsequent color stops of lower value will override the value of the previous color stop creating a hard transition. The following changes from red to yellow at the 30% mark, and then transitions from yellow to blue over 35% of the gradient</p>

<pre class="brush: css notranslate">conic-gradient(red .8rad, yellow .6rad, blue 1.3rad);
</pre>

<p>There are other effects you can create with conic gradients. Oddly, a checkerboard is one of them. By creating quadrants with an upper left and lower right white quadrant and lower left and upper right black quadrants, then repeating the gradient 16 times (four times across and four times down) you can make a checkerboard.</p>

<pre class="brush: css notranslate">conic-gradient(#fff 90deg, #000 0.25turn 0.5turn, #fff 1rad 1.5rad, #000 300grad);
background-size: 25% 25%;
</pre>

<p>And, yes, you can mix and match different angle units, but don't. The above is hard to read.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Browsers do not provide any special information on background images to assistive technology. This is important primarily for screen readers, as a screen reader will not announce its presence and therefore convey nothing to its users. While it is possible to create pie charts, checkerboards, and other effects with conic gradients, CSS images provide no native way to assign alternative text, and therefore the image represented by the conic gradient will not be accessible to screen reader users. If the image contains information critical to understanding the page's overall purpose, it is better to describe it semantically in the document.</p>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable#Guideline_1.1_%E2%80%94_Providing_text_alternatives_for_non-text_content">MDN Understanding WCAG, Guideline 1.1 explanations</a></li>
 <li><a href="https://www.w3.org/TR/2016/NOTE-UNDERSTANDING-WCAG20-20161007/text-equiv-all.html">Understanding Success Criterion 1.1.1 | W3C Understanding WCAG 2.0</a></li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Gradient_at_40-degrees">Gradient at 40-degrees</h3>

<div class="hidden">
<pre class="brush: css notranslate">div {
  width: 100px;
  height: 100px;
}</pre>

<pre class="brush: html notranslate">&lt;div&gt;&lt;/div&gt;
</pre>
</div>

<pre class="brush: css notranslate">div {
  background-image:
     conic-gradient(from 40deg, #fff, #000);
}
</pre>

<p>{{EmbedLiveSample("Gradient_at_40-degrees", 120, 120)}}</p>

<h3 id="Off-centered_gradient">Off-centered gradient</h3>

<div class="hidden">
<pre class="brush: css notranslate">div {
  width: 100px;
  height: 100px;
}</pre>

<pre class="brush: html notranslate">&lt;div&gt;&lt;/div&gt;
</pre>
</div>

<pre class="brush: css notranslate">div {
  background: conic-gradient(from 0deg at 0% 25%, blue, green, yellow 180deg);
}</pre>

<p>{{EmbedLiveSample("Off-centered_gradient", 120, 120)}}</p>

<h3 id="Gradient_pie-chart">Gradient pie-chart</h3>

<p>This example uses multi-position color stops, with adjacent colors having the same color stop value, creating a striped effect.</p>

<div class="hidden">
<pre class="brush: css notranslate">div {
  width: 100px;
  height: 100px;
}</pre>

<pre class="brush: html notranslate">&lt;div&gt;&lt;/div&gt;
</pre>
</div>

<pre class="brush: css notranslate">div {
  background: conic-gradient(
     red 36deg, orange 36deg 170deg, yellow 170deg);
  border-radius: 50%
}</pre>

<p>{{EmbedLiveSample("Gradient_pie-chart", 120, 120)}}</p>

<h3 id="Checkerboard">Checkerboard</h3>

<div class="hidden">
<pre class="brush: css notranslate">div {
  width: 100px;
  height: 100px;
}</pre>

<pre class="brush: html notranslate">&lt;div&gt;&lt;/div&gt;
</pre>
</div>

<pre class="brush: css notranslate">div {
  background:
     conic-gradient(#fff 0.25turn, #000 0.25turn 0.5turn, #fff 0.5turn 0.75turn, #000 0.75turn)
     top left / 25% 25% repeat;
  border: 1px solid;
}</pre>

<p>{{EmbedLiveSample("Checkerboard", 120, 120)}}</p>

<h3 id="More_conic-gradient_examples">More conic-gradient examples</h3>

<p>Please see <a href="/en-US/docs/Web/CSS/CSS_Images/Using_CSS_gradients">Using CSS gradients</a> for more examples.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Images', '#conic-gradients', 'conic-gradient()')}}</td>
   <td>{{Spec2('CSS4 Images')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("css.types.image.gradient.conic-gradient")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Images/Using_CSS_gradients">Using CSS gradients</a></li>
 <li>Other gradient functions: {{CSSxRef("repeating-conic-gradient")}}, {{CSSxRef("linear-gradient")}}, {{CSSxRef("repeating-linear-gradient")}}, {{CSSxRef("radial-gradient")}}, {{CSSxRef("repeating-radial-gradient")}}</li>
 <li>{{cssxref("&lt;image&gt;")}}</li>
 <li>{{cssxref("_image","image()")}}</li>
 <li>{{cssxref("element()")}}</li>
 <li>{{cssxref("image-set","image-set()")}}</li>
 <li>{{cssxref("cross-fade")}}</li>
</ul>
